$input = "on";
$titlepage = "no";
$opt = $ARGV[0];
if  ($opt =~ /\-/) {shift @ARGV; 
if ($opt =~  /h/ ) {
print "This perl5 script creates a rootfile and massages each worksheet\n";
print "to produce a color LaTeX image of a single worksheet or a book of worksheets.\n";
print "Read through the script to see the modification that are made.\n";
print "You can change the script to make other modifications.\n";
print "Usage: \n";  
print "1. perl -S mkcolor rootname worksheet\n";
print "   where 'rootname' is the name (such as 'notes113.tex') you have\n";
print "   chosen for the root file, and 'worksheet' is the name of\n";
print "   a worksheet exported to latex (such as 'newton.tex').\n";
print "2. perl -S mkcolor rootname worksheetfile\n";
print "   where rootname is as before, and 'worksheetfile' is the name of a\n";  
print "   file containing a list of the worksheets (such as 'texfiles')\n";
print "   you have exported to LaTeX (put one name per line).\n";
print "3. perl -S mkcolor -t  rootfile worksheetfile infofile\n";
print "   where rootfile and worksheetfile are as in 2., and 'infofile' is a file \n";
print "   containing three pieces of information for the cover page.\n";
print "   Use the following format: \n";
print "   TITLE:put complete title \nblank line\n";
print "   AUTHOR:put author info here \nblank line\n";
print "   FRONTPIECE:put name of a picture in eps format for mapleplot.\n";
print "4. Change mkcolor to mkcolor -i in 1 or 2 and mkcolor -t to mkcolor -it to\n";
print "   to suppress the input cells in the LaTeX output.\n";
print "5. perl -S mkcolor -h prints this help screen.\n";
print "Carl Eberhart, Math Dept, University of Kentucky\n";
print "Comments to: carl\@ms.uky.edu\n";
print "June, 1997 (modified December, 1997; April 1, 1998\n";
 exit;}


if ($opt =~ /t/) { $titlepage = "yes"; }
if ($opt =~ /i/) {$input = "off"; print "input off\n";}
}
$mast =  $ARGV[0];
print $mast;
$wkshts = $ARGV[1];

$info = $ARGV[2];


$title = 'TITLE';
$name = 'AUTHOR';
$frontpiece = 'FRONTPIECE';

$/ = "";

if (($titlepage eq "yes") && defined($info) ) {

open(INFO,$info) || print STDOUT "\n no info file. continuing-- \n";

 while (<INFO>) {
 if (/TITLE:([\s\S]+)/) {$title =  $1;  chop($title); }
 if (/AUTHOR:([\s\S]+)/) {$name =  $1;   chop($name);}
 if (/FRONTPIECE:([\s\S]+)/) 
            {$frontpiece =  $1;  chop($frontpiece);}
}
close INFO;
} # end if titlepage = yes

$/ = "\n";

open(MASTER,">$mast") || die "need a name for the rootfile.";
print MASTER "\\documentclass[11pt]\{article\}\n";
print MASTER "\\usepackage\{color,makeidx,theorem,maple2e\}\n";
print MASTER "% tweak these to taste.\n";
print MASTER "% \\AboveMapleSkip	- space above an environment\n";
print MASTER "% \\BelowMapleSkip	- space below an environment\n";
print MASTER " \\AboveMaplePlot = 1\\AboveMapleSkip\n"; 
print MASTER " \\BelowMaplePlot= 1\\BelowMapleSkip\n";
print MASTER "% \\MaplePlotHeight	- vertical space reserved for a plot\n";
print MASTER "% \\MaplePlotWidth	- width reserved for a plot\n";
print MASTER "% \\MaplePlotAngle	- angle of rotatation\n";
print MASTER "% \\LeftMapleSkip 	- the amount of left indentation\n";
print MASTER "% \\MapleFont 		- The Maple font \n";
print MASTER "% \\MapleSize 		- The size of the Maple font in mapleinput and \n";
print MASTER "\\def\\MapleSize\{\\small\}\n";
print MASTER "%                          maplettyout\n";
print MASTER "% \\MapleLatexSize	- The size of the Maple fonts in maplelatex\n";
print MASTER "\\def\\MapleLatexSize\{\\small\}\n"; 
print MASTER "% \\MapleFirstLine	- controls ingoring first line feed\n";
print MASTER "% \\MaplePrompttrue 	- controls insertion of prompt char\n";
print MASTER "% \\MaplePromptString= \{\\raise 1pt \\hbox\{\$\\scriptstyle>\$\\space\}\}\n";
print MASTER "\\MaplePromptString = \{\\space\\space\}\n";
print MASTER "% \\MaplePromptSecondary	- defines the secondary prompt string\n";
print MASTER "% \\MapleSkip		- amount of glue before and after\n";
print MASTER "%			displayed text\n";
print MASTER "% \\MapleTab		- number of spaces per tab (8)\n";
print MASTER "%\n";
print MASTER "%\\renewcommand\{\\familydefault\}\{cmss\}\n";
print MASTER "%\\mathversion\{bold\}\n";
print MASTER "%\\input\{mydefs\}\n";
print MASTER "\\oddsidemargin 0in \n";
print MASTER "\\evensidemargin 0in \n";
print MASTER "\\topmargin -.5in \n";
print MASTER "\\footskip  .5in  \n";
print MASTER "\\textwidth 6.5in \n";
print MASTER "\\textheight 8.5in \n";
print MASTER "% You may need to add your own paragraph styles.\n";
print MASTER "\\DefineParaStyle\{Bullet Item\}\n";
print MASTER "\\DefineParaStyle\{Heading 1\}\n";
print MASTER "\\DefineParaStyle\{Heading 2\}\n";
print MASTER "\\DefineParaStyle\{Heading 3\}\n";
print MASTER "\\DefineParaStyle\{Heading 4\}\n";
print MASTER "\\DefineParaStyle\{code\}\n";
print MASTER "%\\DefineParaStyle\{Problem\}\n";
print MASTER "\\DefineParaStyle\{List Item\}\n";
print MASTER "\\DefineParaStyle\{Dash Item\}\n";
print MASTER "\\DefineParaStyle\{Title\}\n";
print MASTER "\\DefineParaStyle\{Author\}\n";
print MASTER "\\DefineParaStyle\{Warning\}\n";
print MASTER "\\DefineParaStyle\{Maple Plot\}\n";
print MASTER "\\DefineParaStyle\{newpage\}\n";
print MASTER "\\DefineParaStyle\{vfill\}\n";
print MASTER "\\DefineParaStyle\{newpage\}\n";
print MASTER "\\DefineParaStyle\{Fixed Width\}\n";
print MASTER "\\DefineParaStyle\{Error\}\n";
print MASTER "\\DefineParaStyle\{Diagnostic\}\n";
print MASTER "\\DefineParaStyle\{Exercise\}\n";
print MASTER "\\DefineParaStyle\{Maple Output\}\n";
print MASTER "%\\newtheorem\{Definition\}\{\}\n";
print MASTER "\\DefineParaStyle\{Definition\}\n";
print MASTER "\\newtheorem\{Theorem\}\{\}\n";
print MASTER "%\\DefineParaStyle\{Theorem\}\n";
print MASTER "\\DefineParaStyle\{verbatim\}\n";
print MASTER "\\DefineParaStyle\{asis\}\n";
print MASTER "\\DefineParaStyle\{comment\}\n";
print MASTER "\\DefineCharStyle\{2D Comment\}\n";
print MASTER "\\DefineCharStyle\{2D Math\}\n";
print MASTER "\\DefineCharStyle\{Help Heading\}\n";
print MASTER "\\DefineCharStyle\{Hyperlink\}\n";
print MASTER "\\DefineCharStyle\{TXT CMD \}\n";
print MASTER "\\newtheorem\{Problem\}\{\}[subsection]\n";
print MASTER "\\newtheorem\{subproblem\}\{\}[Problem]\n";
print MASTER "\\pagestyle\{headings\}\n";
print MASTER "\n";
print MASTER "\\makeindex\n";
print MASTER "\\begin\{document\}\n";

if ($titlepage eq "yes") {
print MASTER "\\begin\{titlepage\}\n";
print MASTER "\n";
print MASTER "\\vspace*\{1in\}\n";
print MASTER "\n";
print MASTER "\\begin\{center\}\n";
print MASTER "\{\\Huge\\bf $title \}\n";
print MASTER " \n";
print MASTER "\\bigskip\n";
print MASTER "\n";
print MASTER "\{\\sl $name\}\n";
print MASTER "\n";
print MASTER "\\mapleresult\n";
print MASTER "\\mapleplot\{$frontpiece\}\n";
print MASTER "\n";
print MASTER "\\bigskip\n";
print MASTER "\{\\today\}\n";
print MASTER "\\end\{center\}\n";
print MASTER "\\end\{titlepage\}\n";
print MASTER "\\tableofcontents\n";
print MASTER "\n";
} # end if titlepage = yes

open(WORKSHEETS,$wkshts) ||  die "Need a file of worksheets."; 
 
$bf = '  ';
 
read(WORKSHEETS,$bf,2);
close(WORKSHEETS);
if ($bf eq '%%') {@files = ("$wkshts\n");} ;
if ($bf ne '%%') { open(WORKSHEETS,$wkshts); @files = <WORKSHEETS>; 
close(WORKSHEETS);}
 
foreach $file (@files) {

chop $file;

if ($file !~ m/\.tex$/) 
{close(MASTER); die "$file is not a tex file: \n";  }
elsif (!open(TEXTFILE ,$file)) 
{ close(MASTER); die "Can't open $file: \n";} 
else {close(TEXTFILE);
$file =~ s/\.tex//;

&prepfile($file); 


print MASTER "\\include\{$file\}\n";
} 
} 
print MASTER "\\end\{document\}\n"; 

close(MASTER);

exit;

 
# subroutine to massage an individual worksheet tex file.

sub prepfile {
local($file) = @_;

$tfile = "$file\.tex";


# read file by paragraph (blank lines separate).

$/ = "";

# need this to fix mapleinput format

$first = "\}\{\%\n\}\n\\mapleinline\{active\}\{1d\}\{\\color\{red\}\n"; 


open(FILE,"<$tfile");
$bfile = "$file\.pbak";
open(TMP,">$bfile");

while (<FILE>) {

#  comment out the top and bottom of the file

if (/\%\\document/) { 
 print STDERR "$tfile already prepped.\n";  $/ ="\n";
return; }

# else go on to prep it.

s/\\documentclass/\%\\documentclass/; s/\\usepackage/\%\\usepackage/;
s/\\DefineParaStyle/\%\\DefineParaStyle/g;
s/\\DefineCharStyle/\%\\DefineCharStyle/g;
s/\\begin\{document\}/\%\\begin\{document\}/ ;
s/\\end\{document\}/\%\\end\{document\}/ ; 

#
# Make latex substitutions
# 

s/\\TEXTsymbol\{\\\}/\$\\backslash\$/g;
s/maplettyout/asis/g;

s/\{\\[ir][tm][ \n]*subset\}/ \\subset /g;
s/\{\\[ir][tm][ \n]*Union\}/ \\cup /g;
s/Union\\ / \\cup /g;
s/\{\\[ir][tm][ \n]*union\}/ \\cup /g;
s/\{\\[ir][tm][ \n]*Intersect\}/ \\cap /g;
s/\{\\[ir][tm][ \n]*intersect\}/ \\cap /g;
s/\{\\[ir][tm] minus\}/ \\setminus /g;
s/\{\\[ri][mt][ \n]*ray[\}\(\{\\it \n\,]*([\w][\w])\}[ \,\n]*/\\stackrel\{\\longrightarrow\}\{\\rm $1\}/g;
s/ray\\ ([\w][\w])/\\stackrel\{\\longrightarrow\}\{\\rm $1\}/g;
s/\{\\[ir][tm][ \n]*line[\}\(\{\\it \n\,]*([\w][\w])\}[ \,\n]*/\\stackrel\{\\longleftrightarrow\}\{\\rm $1\}/g;
s/line\\ ([\w][\w])/\\stackrel\{\\longleftrightarrow\}\{\\rm $1\}/g;
s/\{\\[ir][tm][ \n]*segment[\}\(\{\\it \n\,]*([\w][\w])\}[ \,\n]*/\\overline\{\\rm $1\}/g; 
s/segment\\ ([\w][\w])/\\overline\{\\rm $1\}/g; 
s/\{\\[ir][tm][ \n]*angle\}/ \\angle /g;
s/angle\\ / \\angle/g;
s/\{\\[ir][tm][ \n]*triangle\}/ \\triangle /g;
s/triangle\\ / \\triangle/g;

# fix a major bug in the formatting of mapleinputlines 
# if input is turned on

if ($input eq "on") {


if (/(\\begin\{mapleinput\}[\s\S]+\\end\{mapleinput\})/) { 

if  (/(\{1d\}([\s\S]+)\}\{\%)/) { 
   $line = $1;  
   $sline = $line;
    $sline =~ s/^\{1d\}\{/\{1d\}\{\\color\{red\}/;
    $sline =~ s/\n/$first/g;     
   $line  =~ s/(\W)/\\$1/g;
   s/$line/$sline/;  
       }   
}
}

# turn input off.

if ($input eq "off") { 
s/\{1d\}/\{2d\}/g;
}


# put in the external diagrams

if (/\\begin\{diagram\}\n(.*)\n\\end\{diagram/) {
$_ =
"\\mapleresult\n\\begin\{center\}\n\\mapleplot\{$1\.eps\}\n\\end\{center\}\n\n"; } 

#  replace mapleplot with includegraphics
s/\\mapleplot/\\includegraphics\[width\=4in\,height\=6in\,angle\=-90\]/;

# put in newpages and vfills
s/\\begin\{newpage\}\n\\end\{newpage\}/\n\\newpage\n/;

if (/\\begin\{vfill\}\n\\end\{vfill\}/) {
$_ = "\n\\vfill\n";
}

# handle user defined character styles word, bookmark.

if (/\\QTR\{word\}\{(.*) {2,5}/) { $t = $1;
 s/\\QTR\{word\}//;
 $t1  = $t; $t =~ s/(\W)/\\$1/g; 
 $t1 =~ s/$t/\\color[rgb]\{0,.5,0\}\\index\{$t1\}$t1\}\{/;  
 s/$t/$t1/;}
# $t1  = $t; $t =~ s/(\W)/\\$1/g;   
# s/$t/$t1\}\{/;}

if (/\\QTR\{Bookmark\}\{([^\ ]+)[\ ]{1,5}/) { $t = $1; 
 s/\\QTR\{Bookmark\}//;
 $t1  = $t; $t =~ s/(\W)/\\$1/g; 
 $t1 =~ s/$t/\\color[rgb]\{0,.5,0\}\\index\{$t1\}$t1\}\{/;  
 s/$t/$t1/;}

if (/\\QTR\{TXT[ \n]+CMD\}\{(.*) {2,5}/) { $t = $1; 
 s/\\QTR\{TXT[ \n]+CMD\}\{/\{\\tt /;
 $t1  = $t; $t =~ s/(\W)/\\$1/g; 
 $t1 =~ s/$t/\\color[rgb]\{0,.5,0\}\\index\{$t1\}$t1\}\{/;  
 s/$t/$t1/;}

s/\\begin\{maplelatex\}/\\begin\{maplelatex\}\\color\{blue\}/;
s/\\begin\{Problem\}/\\begin\{Problem\}\\color[rgb]\{.14,.14,.57\}/;
s/\\begin\{Theorem\}/\\begin\{Theorem\}\\color[rgb]\{.14,.14,.57\}/;


# get rid of leading hyperlinks.

if (/\\QTR\{Hyperlink\}\{([\w ]+)\}/) {
  s/$1/ /; }

# get rid of QTR

s/\\QTR\{[^\{]+//g; 
 
# modify Bullet item

if (/\\begin\{Bullet/ || /\\end\{Bullet/) {
s/\\begin\{Bullet Item\}\n/\\begin\{maplegroup\}\n\\smallskip\\noindent\n/;
s/\\end\{Bullet Item\}/\\smallskip\n\\end\{maplegroup\}/; }

# modify the title line

if (/\\begin\{Title/) {s/\\small/\\Large\\bf/};

# massage the asis paragraph style so that it prints out 'as is'
# this includes leading and inside blanks.

   if  (/\\begin\{asis\}([\s\S]+)\\end\{asis\}/) { 
  $t = $1; $t1 = $t;  $t =~ s/(\W)/\\$1/g; 
  $t1 =~ s/\n/\n\\end\{asis\}\n\n\\begin{asis\}\\color[rgb]\{.6,.4,.2\}\n/g; 
  $t1 =~ s/ /\\ /g; 
   s/$t/$t1/;  }

# massage the comment paragraph style to comment out the latex comments.

s/\\begin\{comment\}\n/\\begin\{comment\}\n\%/;

 

# print the line.   
   
print TMP;

}
close(TMP); close(FILE);
rename($bfile,$tfile);

}

